#include "../lib/jsmn/jsmn.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// my everlasting commitment to ridding code of magic numbers :)
#define MEMORY_SIZE 65535
#define BUFFER_SIZE 32767
#define MAX_TOKEN_LENGTH 32767

int memory[MEMORY_SIZE];

int sp, fp = MEMORY_SIZE; /* no idea what these are yet, when i figure that out i'll rename them something better */
int img, but, lab, tab = 0; /* renaming these too */


int main(int argc, char* argv[]) {
    
    if (argc < 2) {
        printf("Error: Did not specify file.");
        return EXIT_FAILURE;
    } else if (argc > 2) {
        printf("Error: Too many arguments!");
        return EXIT_FAILURE;
    }
    
    FILE *executable = fopen(argv[1], "r");

    if (executable == NULL) {
        printf("Error: Could not locate %s", argv[1]);
        return EXIT_FAILURE;
    }

    char buffer[BUFFER_SIZE];

    while(fgets(buffer, BUFFER_SIZE-1, executable) != NULL) {
        char instruction_set[BUFFER_SIZE];
        jsmn_parser parser;
        jsmntok_t tokens[MAX_TOKEN_LENGTH];

        // cleanup for easier jsmm parsing

        // first line has a weird header
        int header = (buffer[0] == 'v') ? strlen("var tape='") : 0;
        
        // make sure the brackets are valid in the context of this line
        for (int i = header; buffer[i] != 0; i++) {
            instruction_set[i-header] = buffer[i];
            if (buffer[i] == '\\'  && header > 0) {
                instruction_set[i - header] = 0;
                instruction_set[i - header - 1] = ']';
            } else if (buffer[i] == '\\'  || buffer[i] == '\'') {
                instruction_set[i - header] = 0;
                instruction_set[i - header - 1] = 0;
            }
        }
        
        
        jsmn_init(&parser);
        int result = jsmn_parse(&parser, instruction_set, strlen(instruction_set), tokens, sizeof(tokens) / sizeof(tokens[0]));
    
        // debug line
        printf("%s\n", instruction_set);
        
        if (result < 1 || tokens[0].type != JSMN_ARRAY) {
            printf("Error: Bad JSON, is root token not an array?");
            return EXIT_FAILURE;
        }
        

    }

    return EXIT_SUCCESS;
}
